
	<<Readline module for Gauche>>

 これは GNU Readline/BSD libedit を Scheme 言語の Gauche でサポートす
る仕組みです。
 動かすには Gauche-0.8.10 以降が必要です。



Usage:
 "./configure" を実行して適切な Makefile を作成し、その後 "make" 等で
コンパイルして下さい。
"gosh -I . gosh-rl.scm" や "make run" で Readline を用いた Gauche の
対話モードを実行します。
"make install" でインストールします。インストールを行うと "gosh-rl"
コマンドが使えるようになります。

 キーボードからの入出力は標準的な Readline の機能がそのまま使えます。
上下キーや <Ctrl>-p/n キーで履歴を遡り、左右キーや <Ctrl>-b/f キーで
編集位置を移動させます。また <Ctrl>-r で履歴検索も出来ます。
 "~/.inputrc" を編集すると Readline のさまざまな機能を変更できます。
例えば、閉じ括弧の入力で対応する開き括弧の位置を知る機能を使用する場合は
以下のような行をあなたの "~/.inputrc" ファイルに記述して下さい。
詳しくは Readline のマニュアルを参照して下さい。
-----------------------------
$if Gauche
  set blink-matching-paren on
$endif
-----------------------------

Functions:
 (make-readline-input-port)
	Readline を用いた入力ポートを作成します。入力は一旦内部バッファ
	にセーブされ、(rl-commit-history!)でまとめて履歴に書き出します。

 (rl-commit-history!)
	(make-readline-input-port)の入力で蓄積された入力を履歴にまとめ
	て書き出します。

 (rl-readline "prompt string")
	"prompt string" を表示して入力待ちになります。
	入力結果は <string> 形式で返ります。
	EOF に到達したり、その他の問題があった場合は #f が返ります。

 (rl-add-history! "string")
	"string" を Readline の履歴に追加します。

 (rl-read-history! "filename")
	ファイル "filename" から Readline の履歴を復元します。

 (rl-write-history "filename")
	ファイル "filename" に Readline の履歴を保存します。

 (rl-set-application-name! <"string"|#f>)
	Readline の "~/.inputrc" によるカスタマイズ時のアプリケーションの
	固有名を "string" にします。 #f で設定を無効にします。

 (rl-stifle-history! number)
	履歴の最大保存数を設定します。


Q&A:
Q1: 漢字が入出力できません。
A1: Gauche-readline 自身は漢字コードに依存してはいません。Gauche-readline が
    漢字の入出力が出来るかどうかは端末自身が漢字の入出力が出来るかどうかにか
    かっています。

    漢字の入出力には、使用している端末が漢字の入出力をサポートしている必要が
    あります。さらに、 Gauche のサポートする漢字コードの形式(UTF-8,EUC-JP等)
    と端末の漢字コードの形式を同じものにして下さい。漢字入力を正しく行うため
    には端末ソフト起動時に環境変数 "LANG" を正しく設定され、それに併せて漢字
    入力用のプログラムが正しく動作している必要もあります。

    また、readline が8ビット文字を扱える必要があります。
    rluserman(3readline)を参考に input-meta/output-meta の設定を検討して下
    さい。例えば "~/.inputrc" で以下のように設定します。昨今ではこの設定は
    システム側で標準で設定されている事が多いようです。
------------------
set input-meta on
set output-meta on
------------------

Q2 BSD libedit ライブラリは使用できますか。
A3 BSD libedit ライブラリは GNU readline ライブラリとほぼ互換の機能を
   持つライブラリですが、文字列を囲む " や ' などの記号類の扱いを変更
   できません。そのため ' 記号を多用すると履歴表示がおかしくなる事があ
   ります。Scheme では ' を別の意味に用いるので履歴中に ' を含むように
   なるとおかしくなるようです。可能なら GNU readline を使用して下さい。


By: YOKOTA Hiroshi (yokota-at-netlab.cs.tsukuba.ac.jp)
